%% Apply affine transformation
%  Created: Jan 3rd, 2011
%
function [I,sx,sy] = imaffine(I,T,mode)

    if nargin<3; mode = 'nearest'; end;
    
    % applying transformation
    nx = size(I,2);
    ny = size(I,1);
    [y,x] = ndgrid(1:nx,1:ny); % apply transformation
    coord  = [x(:) y(:)];
    coord(:,3) = 1;
    coordp = coord * T;
    x_prime = reshape(coordp(:,1),ny,nx);
    y_prime = reshape(coordp(:,2),ny,nx);
    sx = x_prime - x; % displacement
    sy = y_prime - y;
    
    I = interpn(y,x,I,y_prime,x_prime,mode,0);

end

