%% Resize image
function I = imresize_multichannel(I,scale)

    if scale==1; return; end; % no smoothing
    
    if size(I,1)*scale<1 | size(I,2)*scale<1; error(['Scale ' num2str(1/scale) ' is too large']); end;
    
    nchannels = size(I,3);

    for i=1:nchannels
        Ip(:,:,i) = imresize(I(:,:,i),scale);
    end
    
    I = Ip;

end


