%% Display several images on the same figure
%  Changed: Dec 9th, 2011
%
function showimagesc(varargin)

    % Check parameters
    nb_args   = size(varargin,2);
    crange    = [0 1]; % default image intensities
    
    for i=1:nb_args
        if ischar(varargin{i})
            if isequal(varargin{i},'lim')
                lim       = varargin{i+1};
            elseif isequal(varargin{i},'caxis')
                crange    = varargin{i+1};
            end
        end
    end
    
    colormap gray;
    
    % Display images
    I = varargin{1};
    imagesc(I,crange);
    daspect([1 1 1]);
    if exist('lim'); axis([lim(3)-0.5 lim(4)+0.5 lim(1)-0.5 lim(2)+0.5]); end
    axis off;
    if nb_args>1 && ischar(varargin{2})
        title(varargin{2});
    end
        
end
