%% Display vector field
%  Changed: Dec 11th, 2011
%
function showvector(ux,uy,downsample,scale,lim,color)

    if nargin<3; downsample = 1; end;
    
    sizex = size(ux,1);
    sizey = size(uy,2);
    
    ux  = ux(1:downsample:end, 1:downsample:end);
    uy  = uy(1:downsample:end, 1:downsample:end);
    
    if nargin<4; scale = 3;                     end; % Scale vector to show small ones
    if nargin<5; lim   = [1 sizex 1 sizey]; end; % Display whole image

    [y,x] = ndgrid((1:downsample:sizex), (1:downsample:sizey)); % coordinate image
    if nargin<6
        quiver(x,y,ux,uy,scale);                  % show vectors
    else
        quiver(x,y,ux,uy,scale,'color',color);    % show vectors
    end
    daspect([1 1 1]);
    axis([lim(3)-0.5 lim(4)+0.5 lim(1)-0.5 lim(2)+0.5]);      % which vector to show
    set(gca,'YDir','reverse');
    
end

